/* */
call rxfuncadd 'sysloadfuncs', 'rexxutil', 'sysloadfuncs';
call sysloadfuncs
call RxFuncAdd 'RexxwebLoadFuncs', 'REXXWEB', 'RexxwebLoadFuncs'
call RexxwebLoadFuncs

say 'Content-Type: text/html'
say 'Cache-control: no-store';
say 'Pragma:No-Cache'; say '';

env = "OS2ENVIRONMENT"
SSL=value("HTTPS",,env)

/* if SSL = 'OFF' then
  do
	say "ॡ 饭 ᮥ !" ; say "<br>"
        say "  稭  ⮪ HTTPS://"
        exit
  end */

curdir=directory()
cfg=curdir||"\webweasel.cfg";

string=strip(linein(cfg,1,1))

if string="" then
  do
   say ""; say "Errors with Webweasel.cfg"; say ""
   exit
  end

do while string \= ""
  if substr(string,1,1) \= ';' THEN
     SELECT
     when pos("domain=",string)
          then
              domain=substr(string,8)
     when pos("timeref=",string)
          then
              timeref=substr(string,9)
     when pos("ini=",string)
          then
              ini=substr(string,5)
     when pos("cgi=",string)
          then
              cgi=substr(string,5)
     when pos("html=",string)
          then
              html=substr(string,6)
     when pos("url=",string)
          then
              url=substr(string,5)
     when pos("images=",string)
          then
              images=substr(string,8)
     when pos("mNotFound=",string)
          then
              mNotFound=substr(string,11)
     when pos("mIniError=",string)
          then
              mIniError=substr(string,11)
     when pos("mNotFiles=",string)
          then
              mNotFiles=substr(string,11)
     when pos("mDeleted=",string)
          then
              mDeleted=substr(string,10)
     when pos("mNoDeleted=",string)
          then
              mNoDeleted=substr(string,12)
     when pos("mExEmail=",string)
          then
              mExEmail=substr(string,10)
     when pos("mNotDelOld=",string)
          then
              mNotDelOld=substr(string,12)
     when pos("mSaveErr=",string)
          then
              mSaveErr=substr(string,10)
     when pos("mSaveSucc=",string)
          then
              mSaveSucc=substr(string,11)
     when pos("mDirErr=",string)
          then
              mDirErr=substr(string,9)
     when pos("mNoFwd=",string)
          then
              mNoFwd=substr(string,8)
     OTHERWISE
         say "UNKNOWN PARAMETER to WEBWEASEL.CFG"
     END
  string=strip(linein(cfg));
end
rc=lineout(cfg)

rc = getformdata()
if rc=0 then
  do
   rc = getfielddata('job',0,'T','L',job)
   rc = getfielddata('name',0,'T',name)
   rc = getfielddata('email',0,'T','L',email)
   rc = getfielddata('emailold',0,'T',emailold)
   rc = getfielddata('comm',0,'T',comm)
   rc = getfielddata('pass',0,'T','L',pass)
   rc = getfielddata('yesdel',0,'T',yesdel)
  end

SELECT
   WHEN job="delete"
      THEN 
        call Dead
   WHEN job="print"
      THEN
        call LIST
   WHEN job="list"
      THEN
        call LIST
   WHEN job="edit"
      THEN 
        call Editor
   WHEN job="find"
      THEN 
        call Editor
   WHEN job="save"
      THEN 
        call Save
   WHEN job="new"
      THEN 
        call Editor 
   WHEN job="forward"
      THEN 
        call Forward
   OTHERWISE
   DO
     cForward=noForward()
     mainhtml=html||'main.htm'
     rc=getTextFile(mainhtml,'main')
     if rc=1 then
         Call MESS mNotFiles mainhtml
     else
         say main          
   END
END  
say "<font size=-3>Rev. 003 (C) P.Ro. 2002</font>"
say "</body></html>"
EXIT
/*****************************/
Forward:
   MailRoot=SysIni( ini, '$SYS', 'MailRoot') 
   MailRoot=substr(MailRoot,1,LASTPOS("\",MailRoot))
   rc=SysFileTree(MailRoot||'\forward\*.FWD','file.','FO','**+**')

if file.0=0 then
   do
     Call MESS mNoFwd
     return
   end

fwdhtml=html||'fwd.htm'
rc=getTextFile(fwdhtml,'fwd')

if rc=1 then
     do
      call MESS mNotFiles fwdhtml
      return
     end

say fwd

do i=1 to file.0

 v000=charin(file.i,9,1)
 string=charin(file.i,12,100)
 rc=charout(file.i)
 RPOS=pos(")",string)-1
 string=substr(string,1,RPOS)
 emailpos=pos(">(",string)
 emailfrom=substr(string,1,emailpos-1)
 emailto=substr(string,emailpos+2)
 cont=x2d(c2x(v000))
 say "<tr><td bgcolor='#ffffff'>" || i || "</td><td bgcolor='#ffffff'>" || emailfrom ||"</td><td bgcolor='#ffffff'>" || emailto || "</td><td bgcolor='#ffffff'>" || cont || "</td></tr>"

end
 say "</table>"

return
/*****************************/
NoForward:
   MailRoot=SysIni( ini, '$SYS', 'MailRoot') 
   MailRoot=substr(MailRoot,1,LASTPOS("\",MailRoot))
   rc=SysFileTree(MailRoot||'\forward\*.FWD','file.','FO','**+**')
return file.0
/*****************************/
Dead :

if TRANSLATE(yesdel) \= "YES" THEN
   do
    call MESS mNoDeleted email
    return
   end

  rc=SysIni(ini, email, 'DELETE:')
    if rc \= '' then
                   do
                    call MESS mIniError ini
                    return
                   end
    call MESS mDeleted email
return
/*****************************/
Save :

if emailold \= email then
do
  rc=SysIni(ini, email, 'ALL:', 'keys.')
  if rc = '' then
    do
     call MESS mExEMail email
     return
    end
end

if emailold \= '' then
 do
   /* 㤠塞 ஥ */
   rc=SysIni(ini, emailold, 'DELETE:')
   if rc \= '' then
           do
            call MESS mNotDelOld emailold
            return
           end
 end

 /* 뢠  */
 if Name = '' then
     Name='-----'
 if Comm = '' then
     Comm='-----'
   rc1=SysIni( ini, email, 'RealName', Name) 
   rc2=SysIni( ini, email, 'Password', Pass)
   rc3=SysIni( ini, email, 'Comments' , Comm)
 /* email   - ᮧ dir*/
 if compare(email,emailold) \=0 then
  do
   MailRoot=SysIni( ini, '$SYS', 'MailRoot') 
   MailRoot=substr(MailRoot,1,LASTPOS("\",MailRoot))
   rc=SysMkDir(MailRoot||"\"||email)
   if rc \= 0 then
       do
         call MESS mDirErr rc
         return
       end    
  end

   if rc1='' & rc2='' & rc3='' then
       call MESS mSaveSucc
   else
       call MESS mSaveErr
return
/*****************************/
Editor:

if email='' then
                 job='new'

if job \= 'new' then
  do
   edithtml=html||'edit.htm'
   Pass=SysIni(ini,email,'Password')
   if Pass="ERROR:" then
      do
       call MESS mNotFound
       return
      end
   Name=SysIni(ini,email,'RealName')
   Comm=SysIni(ini,email,'Comments')
  end
else
  do
    edithtml=html||'new.htm'
    email=''
    Pass=''
    Name=''
    Comm=''
  end

rc=getTextFile(edithtml,'editing')

if rc=1 then
     do
      call MESS mNotFiles edithtml
      return
     end

say editing
return
/*****************************/

LIST:

if job="list" then
  listhtml=html||'list.htm'
else
  listhtml=html||'print.htm'


count = 0
rc=SysIni(ini, 'All:', 'Apps.')
 if rc = 'ERROR:' then
   call MESS mIniError ini

  rc=getTextFile(listhtml,'listing')
  if rc=1 then
     call MESS mNotFiles listhtml
  else
   say listing

   do i=1 to Apps.0
          if substr(Apps.i,1,1) \='$' then
           do 
             if (Apps.i \= 'postmaster') then
              do
                email.count=Apps.i
                Password.count=SysIni(ini,Apps.i,'Password')
                RealName.count=SysIni(ini,Apps.i,'RealName')
                Comment.count=SysIni(ini,Apps.i,'Comments')
                count = count + 1
              end 
           end
    end
/* sort */
count=count-1
do i=0 to count-1
   do j=i+1 to count
     tempRealName=RealName.j
     tempPassWord=Password.j
     tempComment=Comment.j
     tempEmail=email.j
    if RealName.i>RealName.j then
      do
        RealName.j=RealName.i; Password.j=Password.i
            Comment.j=Comment.i;   email.j=email.i;
        RealName.i=tempRealName;  Password.i=tempPassword
            Comment.i=tempComment;    email.i=tempEmail;
      end
   end 
end /* sort */

 do i=0 to count
 if Realname.i="" then
      Realname.i="-"
 if Comment.i="" then
      Comment.i="-"

if job="list" then
  say "<tr><td bgcolor='#ffffff'>" || i+1 || "</td><td bgcolor='#ffffff'><a href='" || cgi || "?job=edit&email=" || email.i ||"'>"  || realname.i || "</a></td><td bgcolor='#ffffff'><a href='mailto:"||email.i||"@"||domain || "'>" || email.i || "</a></td><td bgcolor='#ffffff'>" || comment.i || "</td></tr>"
else
  say "<tr><td>" || i+1 || "</td><td>" || realname.i || "</td><td>" || email.i || "</td><td>" || comment.i || "</td></tr>"

 end
say "</table>"
return
/* END MAIN */
/***********/
ERR:
parse arg Result
   if Result = 'ERROR:' then
    do
      call MESS mIniError ini
    end
return 
/**********/
MESS:
parse arg message message1

  metar="<META HTTP-EQUIV='Refresh' CONTENT="||timeref||";URL=" || cgi || ">"
  messhtml=html||'mess.htm'
  rc=getTextFile(messhtml,'messa')
  if rc=1 then
   do
    say messhtml " - NOT FOUND"
    exit
   end
  else
   say messa
exit
/****************/
